SystemOrganization addCategory: #'GT-Spotter-EventRecorder-Analysis'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Builders'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Core'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Roassal'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Support'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Tests'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Traits'!

Trait named: #TGTSpotterCategoryView
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterCategoryView methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 17:58'!
categoryLabelOccurrences
	| col |
	col := OrderedCollection new.
	self categoryLabels asBag 
		doWithOccurrences: [ :obj :occurrences | 
			col add: obj -> occurrences ].
	^ col! !

!TGTSpotterCategoryView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/31/2015 10:03'!
categoryView
	| b ds points |
	b := RTGrapher new.
	points := self categoryLabelOccurrences sortedAs: [ :x :y | x value > y value ].
	points ifEmpty: [ ^ b view ].
	b extent: ((points size * 30) min: 800) @ 150.
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj key asString, ', ', obj value asString, ' times' ].
	ds points: points.
	ds barShape 
			color: (Color green alpha: 0.3); 
			width: 10.
	ds histogramWithBarTitle: #key.
	ds y: [ :obj | obj value ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!TGTSpotterCategoryView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 4/11/2015 23:55'!
gtInspectorCategoryViewIn: composite
	<gtInspectorPresentationOrder: 7>
	composite roassal2
		title: 'Category';
		initializeView: [ self categoryView ]
		! !

Trait named: #TGTSpotterDurationView
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterDurationView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 16:09'!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!TGTSpotterDurationView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 10:56'!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: 5>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

Trait named: #TGTSpotterSessionsTable
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterSessionsTable methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 11:03'!
gtInspectorSessionsIn: composite
	<gtInspectorPresentationOrder: -2>  
	^ (composite table)
		title: 'Sessions';
		display: [ :anEvent | anEvent sessions ];
		column: 'Start' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each start ] width: 155;
		column: 'Duration' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration ] width: 67;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] width: 50;
		column: 'Preview' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each withPreviewSymbol ]
			width: 57;
		column: 'Image Hashes' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each imageHashes size ]
			width: 70;
		showOnly: 50! !

Trait named: #TGTSpotterUpdateEvents
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterUpdateEvents methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 4/9/2015 10:54'!
gtInspectorActionRefreshEvents
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ self updateEvents ];
		icon: Smalltalk ui icons glamorousRefresh;
		title: 'Update events'! !

OrderedCollection subclass: #GTSpotterAnnouncements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

!GTSpotterAnnouncements class methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 00:41'!
developerUUIDs
	"
	GTSpotterEventRecorderSettings ensureComputerID.
	GTSpotterEventRecorderSettings uniqueInstance computerUUID.
	"
	^ #( 	'58d42da6-c993-4ad1-8624-5fd628793610' 
			'4483f704-6909-45d7-9367-869a5850c3e8'
			'52fe7c39-9c98-4fa7-a883-a8b2cabe84db'
			'69202c73-b32f-4968-aaf1-0666d421ea57'
			'0cd69f50-ad08-8c47-84ec-329e2210a2f2'
		)! !

!GTSpotterAnnouncements class methodsFor: 'instance creation' stamp: 'JurajKubelka 3/29/2015 12:41'!
fromDirectory: aFileReference
	"self fromDirectory: './gt/events/' asFileReference"
	^ self 
		withAll: (GTSpotterEventRecorder materializeObjectsFromDirectory: aFileReference)! !

!GTSpotterAnnouncements class methodsFor: 'instance creation' stamp: 'JurajKubelka 3/30/2015 10:07'!
fromLocalDirectory
	^ self fromDirectory: './gt/events/' asFileReference! !

!GTSpotterAnnouncements class methodsFor: 'testing' stamp: 'JurajKubelka 4/12/2015 00:41'!
isDeveloper: anUUID
	^ self developerUUIDs includes: anUUID asString! !

!GTSpotterAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 18:08'!
spotterDevelopers
	"self spotterDevelopers"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
				developers
					sessionsPerComputer
						sessionsWithNumberOfInputsGreaterThenOne! !

!GTSpotterAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 18:07'!
spotterUsers
	"self spotterUsers"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
				users
					sessionsPerComputer
						sessionsWithNumberOfInputsGreaterThenOne! !

!GTSpotterAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 18:08'!
spotterUsersAndDevelopers
	"self spotterUsersAndDevelopers"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
					sessionsPerComputer
						sessionsWithNumberOfInputsGreaterThenOne! !

!GTSpotterAnnouncements methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 00:41'!
developerUUIDs
	^ self class developerUUIDs! !

!GTSpotterAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:30'!
developers
	^ self select: [ :each | self developerUUIDs includes: each computerUUID asString ]! !

!GTSpotterAnnouncements methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 12:42'!
numberOfComputers
	^ self perComputer size! !

!GTSpotterAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:31'!
perComputer
	^ (self groupedBy: [ :each | each computerUUID asString]) as: GTSpotterAnnouncements! !

!GTSpotterAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:21'!
sessions
	^ GTSpotterSessionsBuilder fromEvents: (
			self flatCollect: #events as: OrderedCollection)! !

!GTSpotterAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 14:04'!
sessionsPerComputer
	| group computers |
	group := self perComputer.
	computers := group collect: [ :eachComputer |
		eachComputer sortByTimestamp.
		eachComputer sessions as: GTSpotterComputer.
	] as: GTSpotterComputers.
	computers updateEvents.
	^ computers select: #notEmpty! !

!GTSpotterAnnouncements methodsFor: 'sorting' stamp: 'JurajKubelka 3/29/2015 12:42'!
sortByTimestamp
	^ self sort: [ :a :b | a timestamp < b timestamp ]! !

!GTSpotterAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:31'!
users
	^ self select: [ :each | (self developerUUIDs includes: each computerUUID asString) not ]! !

!GTSpotterAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 12:42'!
withoutEmptyComputerUUID
	^ self select: [ :each | each computerUUID notNil and: [ (each computerUUID = 'nil') not ] ]! !

OrderedCollection subclass: #GTSpotterComputers
	uses: TGTSpotterCategoryView + TGTSpotterUpdateEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTSpotterComputers class
	uses: TGTSpotterCategoryView classTrait + TGTSpotterUpdateEvents classTrait
	instanceVariableNames: ''!

!GTSpotterComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 10:01'!
categoryLabels
	^ self flatCollect: #categoryLabels as: OrderedCollection! !

!GTSpotterComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:24'!
computerUUIDs
	^ self collect: #computerUUID as: OrderedCollection! !

!GTSpotterComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 4/12/2015 00:34'!
computersAndOnlySessionsWithSpecialKeywords
	^ self 
		select: [ :computer | computer hasSessionsWithSpecialKeywords ]
		thenCollect: [ :computer | 
			computer sessionsWithSpecialKeywords	]! !

!GTSpotterComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 4/12/2015 01:03'!
gtInspectorComputersIn: composite
	<gtInspectorPresentationOrder: -2>  
	^ (composite table)
		title: 'Computers';
		display: [ :aComputer | aComputer ];
		column: 'Since' 
			evaluated: [ :each | String streamContents: [ :aStream | 
											each start = 0 
												ifTrue: [ aStream nextPutAll: 'unknown' ]
												ifFalse: [ each start asUTC printYMDOn: aStream ] ] ]
			width: 67;
		column: 'Days' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration asDuration asDays rounded ] 
			width: 40;
		column: 'Spent' 
			evaluated: [ :each | each spentTime ] 
			width: 63;
		column: 'User' 
			evaluated: [ :each | each userOrDeveloperString ] 
			width: 50;
		column: 'Sessions' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] 
			width: 60;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfEvents ] 
			width: 50;
		column: 'Previews' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfPreviews ] 
			width: 60;
		column: 'Inputs' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 47;
		column: 'Diff Inp.' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDifferentSearchStrings ]
			width: 53;
		column: 'Dives In' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesIn ]
			width: 53;
		column: 'Dives Out' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesOut ]
			width: 63;
		column: 'Avg. D-In' 
			evaluated: [ :each | (each avgNumberOfDivesIn printShowingDecimalPlaces: 2)]
			width: 60;
		column: 'Avg. D-Out' 
			evaluated: [ :each | (each avgNumberOfDivesOut printShowingDecimalPlaces: 2) ]
			width: 67;
		column: 'MissSteps' 
			evaluated: [ :each | each numberOfMissSteps ]
			width: 60;
		showOnly: 50! !

!GTSpotterComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 4/8/2015 17:15'!
missSteps
	^ self flatCollect: #missSteps as: GTSpotterSession! !

!GTSpotterComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 15:26'!
numberOfContextChanged
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfContextChanged ! !

!GTSpotterComputers methodsFor: 'helpers' stamp: 'JurajKubelka 4/8/2015 17:16'!
numberOfMissSteps
	^ self missSteps size! !

!GTSpotterComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:04'!
sessions
	^ self flatCollect: #yourself as: GTSpotterSessions! !

!GTSpotterComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:32'!
sessionsWithNumberOfInputsGreaterThen: anInteger
	^ self collect: [ :each | each copy sessionsWithNumberOfInputsGreaterThen: anInteger ]! !

!GTSpotterComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:32'!
sessionsWithNumberOfInputsGreaterThenOne
	^ self sessionsWithNumberOfInputsGreaterThen: 1! !

!GTSpotterComputers methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:43'!
updateEvents
	^ self do: #updateEvents! !

OrderedCollection subclass: #GTSpotterEventCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTSpotterEventCollection subclass: #GTSpotterComputer
	uses: TGTSpotterDurationView + TGTSpotterSessionsTable + TGTSpotterCategoryView + TGTSpotterUpdateEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTSpotterComputer class
	uses: TGTSpotterDurationView classTrait + TGTSpotterSessionsTable classTrait + TGTSpotterCategoryView classTrait + TGTSpotterUpdateEvents classTrait
	instanceVariableNames: ''!

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:35'!
avgNumberOfDivesIn
	self ifEmpty: [ ^ 0 ].
	^ (self sum: #numberOfDivesIn) / self size! !

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:35'!
avgNumberOfDivesOut
	self ifEmpty: [ ^ 0 ].
	^ (self sum: #numberOfDivesOut) / self size! !

!GTSpotterComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 10:01'!
categoryLabels
	^ self flatCollect: #categoryLabels as: OrderedCollection! !

!GTSpotterComputer methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 18:25'!
computerUUID
	self ifEmpty: [ ^ 0 ].
	^ self any computerUUID! !

!GTSpotterComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 15:28'!
differentSearchStrings
	^ self searchStrings asSet! !

!GTSpotterComputer methodsFor: 'gt-inspector-extension' stamp: ''!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!GTSpotterComputer methodsFor: 'gt-inspector-extension' stamp: ''!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: 5>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

!GTSpotterComputer methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 4/9/2015 20:42'!
gtInspectorSessionsIn: composite
	<gtInspectorPresentationOrder: -2>  
	^ (composite table)
		title: 'Sessions';
		display: [ :aComputer | aComputer ];
		column: 'Start' 
			evaluated: [ :each | String streamContents: [ :aStream | | start |
											start := each start.
											start = 0 
												ifTrue: [ aStream nextPutAll: 'unknown' ]
												ifFalse: [
													start asUTC printYMDOn: aStream.
													aStream nextPutAll: ', '.
													start asUTC printHMSOn: aStream ] ] ]
			width: 120;
		column: 'Duration' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration ] width: 67;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] width: 50;
		column: 'Preview' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each previewString ]
			width: 57;
		column: 'MissSteps' 
			evaluated: [ :each | each numberOfMissSteps ]
			width: 67;
		column: 'Inputs' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 47;
		column: 'Diff Inp.' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDifferentSearchStrings ]
			width: 53;
		column: 'Fin. Searches' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 83;
		column: 'Selections' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfUserSelections ]
			width: 70;
		column: 'Dives In' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesIn ]
			width: 53;
		column: 'Close' 
			evaluated: [ :each | each closeActionSymbol ]
			width: 63;
		column: 'Image Hashes' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each imageHashes size ]
			width: 70;
		showOnly: 200! !

!GTSpotterComputer methodsFor: 'testing' stamp: 'JurajKubelka 4/12/2015 00:27'!
hasSessionsWithSpecialKeywords
	^ self anySatisfy: #hasSpecialKeywords! !

!GTSpotterComputer methodsFor: 'testing' stamp: 'JurajKubelka 4/11/2015 23:54'!
hasSpecialKeywords
	^ self anySatisfy: #hasSpecialKeywords! !

!GTSpotterComputer methodsFor: 'testing' stamp: 'JurajKubelka 4/12/2015 00:43'!
isDeveloper
	^ GTSpotterAnnouncements isDeveloper: self computerUUID! !

!GTSpotterComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/8/2015 17:14'!
missSteps
	^ self flatCollect: #missSteps as: GTSpotterSession! !

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/31/2015 15:26'!
numberOfContextChanged
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfContextChanged! !

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/31/2015 15:27'!
numberOfDifferentSearchStrings
	^ self differentSearchStrings size! !

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:34'!
numberOfDivesIn
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfDivesIn	! !

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:34'!
numberOfDivesOut
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfDivesOut! !

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:34'!
numberOfEvents
	self ifEmpty: [ ^ 0 ].
	^ self sum: #size! !

!GTSpotterComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:30'!
numberOfPreviews
	^ self sessionsWithPreview size! !

!GTSpotterComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 15:30'!
searchStrings
	^ self flatCollect: #searchStrings as: Bag! !

!GTSpotterComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:22'!
sessionsWithNumberOfInputsGreaterThen: anInteger
	^ self select: [ :each | each numberOfContextChanged > anInteger ]! !

!GTSpotterComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:22'!
sessionsWithNumberOfInputsGreaterThenOne
	^ self sessionsWithNumberOfInputsGreaterThen: 1! !

!GTSpotterComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:32'!
sessionsWithPreview
	^ self select: #isWithPreview! !

!GTSpotterComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/11/2015 23:59'!
sessionsWithSpecialKeywords
	^ self select: #hasSpecialKeywords! !

!GTSpotterComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/12/2015 01:01'!
spentTime
	self ifEmpty: [ ^ 0 seconds ].
	^ self sum: #duration! !

!GTSpotterComputer methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 10:45'!
start
	self ifEmpty: [ ^ 0 ].
	^ self first start! !

!GTSpotterComputer methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 17:05'!
stop
	self ifEmpty: [ ^ 0 ].
	^ self last stop! !

!GTSpotterComputer methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:43'!
updateEvents
	^ self do: #updateEvents! !

!GTSpotterComputer methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 00:44'!
userOrDeveloperString
	^ self isDeveloper
			ifTrue: [ 'dev' ]
			ifFalse: [ 'user' ]! !

!GTSpotterEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:40'!
contextChanges
	^ self select: #isContextChanged! !

!GTSpotterEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 13:14'!
differentSearchStrings
	^ self searchStrings asSet! !

!GTSpotterEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:24'!
divesIn
	^ self select: #isDiveIn! !

!GTSpotterEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:24'!
divesOut
	^ self select: #isDiveOut! !

!GTSpotterEventCollection methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 17:16'!
duration
	^ self stop - self start! !

!GTSpotterEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:55'!
finishedSearches
	^ self select: #isSearchFinished! !

!GTSpotterEventCollection methodsFor: 'testing' stamp: 'JurajKubelka 4/9/2015 10:51'!
hasMissSteps
	^ self missSteps notEmpty! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:40'!
numberOfContextChanged
	^ self contextChanges size! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 12:15'!
numberOfDifferentSearchStrings
	^ self differentSearchStrings size! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:24'!
numberOfDivesIn
	^ self divesIn size! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:24'!
numberOfDivesOut
	^ self divesOut size! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:54'!
numberOfFinishedSearches
	^ self finishedSearches size! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 4/9/2015 10:52'!
numberOfMissSteps
	^ self missSteps size! !

!GTSpotterEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:43'!
numberOfUserSelections
	^ self userSelections size! !

!GTSpotterEventCollection methodsFor: 'printing' stamp: 'JurajKubelka 3/30/2015 13:15'!
sessionPopupText
	^ String streamContents: [ :aStream |
			aStream
				nextPutAll: 'Duration: ';
				print: self duration;
				cr;
				nextPutAll: 'Events: ';
				print: self size;
				cr;
				nextPutAll: 'Number of user input changes: ';
				print: self numberOfContextChanged;
				cr;
				nextPutAll: 'Number of different search strings: ';
				print: self numberOfDifferentSearchStrings;
				cr;
				nextPutAll: 'Number of finished searches: ';
				print: self numberOfFinishedSearches;
				cr;
				nextPutAll: 'Number of user item selections: ';
				print: self numberOfUserSelections;
				cr;
				nextPutAll: 'Dive in/out: ';
				print: self numberOfDivesIn;
				nextPut: $/;
				print: self numberOfDivesOut;
				cr;
				"using of #i, etc."
				nextPutAll: (self isWithPreview ifTrue: [ 'With Preview' ] ifFalse: [ 'Without Preview' ])
		 ]! !

!GTSpotterEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:44'!
userSelections
	^ self select: #isUserSelection! !

GTSpotterEventCollection subclass: #GTSpotterSession
	uses: TGTSpotterCategoryView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTSpotterSession class
	uses: TGTSpotterCategoryView classTrait
	instanceVariableNames: ''!

!GTSpotterSession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 17:47'!
categoryLabels
	^ self categorySelections collect: #categoryLabel as: OrderedCollection! !

!GTSpotterSession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 17:45'!
categorySelections
	^ self select: #isCategorySelection! !

!GTSpotterSession methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 10:50'!
closeActionSymbol
	self ifEmpty: [ ^ #empty ].
	^ self last closeActionSymbol! !

!GTSpotterSession methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 18:25'!
computerUUID
	self ifEmpty: [ ^ 0 ].
	^ self any computerUUID! !

!GTSpotterSession methodsFor: 'comparing' stamp: 'JurajKubelka 4/9/2015 20:19'!
deepestDiveIn
	^ self max: #diveInLevel! !

!GTSpotterSession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 4/11/2015 22:50'!
gtInspectorEventsIn: composite
	<gtInspectorPresentationOrder: -2>  
	^ (composite table)
		title: 'Events';
		display: [ :aSession | aSession ];
		column: 'Event' 
			evaluated: [ :each | each asEventAnalysisString ] width: 400;
		column: 'Time' 
			evaluated: [ :each | GTSpotterPrintDateAndTime yyyyMmDdAndHhMmSs: each dateAndTimeWithFixedTimeZone ]
			width: 120;
		withSmalltalkSearch;
		helpMessage: 'Given your INPUT, it executes: self select: [:each | INPUT ]';
		showOnly: 200! !

!GTSpotterSession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/31/2015 13:53'!
gtInspectorStrangeEventsIn: composite
	<gtInspectorPresentationOrder: 9>  
	^ (composite tree)
		title: 'Strange';
		display: [ :aSession | aSession select: #isStrange ];
		children: [ :eachChild |
			eachChild isString 
				ifTrue: [ #() ]
				ifFalse: [ eachChild strange ] ];
		format: [ :eachEvent | 
			eachEvent isString 
				ifTrue: [ eachEvent ]
				ifFalse: [ eachEvent asEventAnalysisString, 
								' with ', eachEvent strange size asString, ' strange observations.' ] ]! !

!GTSpotterSession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 4/10/2015 15:35'!
gtInspectorTimelineView2In: composite
	<gtInspectorPresentationOrder: 6>
	composite roassal2
		title: 'Timeline 2';
		initializeView: [ self timelineView2 ]
		! !

!GTSpotterSession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 4/9/2015 14:52'!
gtInspectorTimelineViewIn: composite
	<gtInspectorPresentationOrder: 5>
	composite roassal2
		title: 'Timeline';
		initializeView: [ self timelineView ]
		! !

!GTSpotterSession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/31/2015 13:45'!
gtInspectorTreeEventsIn: composite
	<gtInspectorPresentationOrder: -1>  
	^ (composite tree)
		title: 'Tree';
		display: [ :aSession | aSession roots ];
		children: [ :eachChild |
			eachChild children ];
		format: [ :eachEvent | eachEvent asEventAnalysisString ]
		! !

!GTSpotterSession methodsFor: 'testing' stamp: 'JurajKubelka 4/11/2015 23:53'!
hasSpecialKeywords
	^ self anySatisfy: [ :each | each isContextChanged and: [ each hasCurrentTextSpecials ] ]! !

!GTSpotterSession methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 17:19'!
imageHashes
	^ (self collect: #imageHash as: OrderedCollection) removeDuplicates! !

!GTSpotterSession methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:45'!
isWithPreview
	^ (self contains: #isShowPreview) and: [ 
			(self contains: #isHidePreview) not ]! !

!GTSpotterSession methodsFor: 'enumerating' stamp: 'JurajKubelka 4/8/2015 17:12'!
missSteps
	^ self select: #isMissStep ! !

!GTSpotterSession methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 15:50'!
previewString
	^ self isWithPreview
		ifTrue: [ 'yes' ]
		ifFalse: [ 'no' ]! !

!GTSpotterSession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 13:04'!
roots
	^ self select: #isRootEvent! !

!GTSpotterSession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 13:10'!
searchStrings
	^ ((self select: #isContextChanged)
			flatCollect: #currentTextHashes as: Bag)! !

!GTSpotterSession methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 22:50'!
start
	self ifEmpty: [ ^ 0 ].
	^ self first dateAndTimeWithFixedTimeZone! !

!GTSpotterSession methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 22:50'!
stop
	self ifEmpty: [ ^ 0 ].
	^ self last dateAndTimeWithFixedTimeZone! !

!GTSpotterSession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 4/10/2015 15:26'!
timelineView
	^ GTATimelineBuilder viewOn: self! !

!GTSpotterSession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 4/10/2015 15:34'!
timelineView2
	^ GTSpotterTimeline viewOn: self! !

!GTSpotterSession methodsFor: 'update' stamp: 'JurajKubelka 4/9/2015 11:13'!
updateEvents
	^ GTSpotterSessionAnalysis updateOn: self! !

OrderedCollection subclass: #GTSpotterSessions
	uses: TGTSpotterDurationView + TGTSpotterUpdateEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTSpotterSessions class
	uses: TGTSpotterDurationView classTrait + TGTSpotterUpdateEvents classTrait
	instanceVariableNames: ''!

!GTSpotterSessions methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 10:36'!
duration
	^ self stop - self start! !

!GTSpotterSessions methodsFor: 'gt-inspector-extension' stamp: ''!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!GTSpotterSessions methodsFor: 'gt-inspector-extension' stamp: ''!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: 5>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

!GTSpotterSessions methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 11:20'!
numberOfEvents
	^ self sum: #size! !

!GTSpotterSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 10:37'!
sessions
	^ self! !

!GTSpotterSessions methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 10:37'!
start
	^ (self detectMin: #start) ifNil: [ 0 ] ifNotNil: [ :obj | obj start ]! !

!GTSpotterSessions methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 10:38'!
stop
	^ (self detectMax: #stop)  ifNil: [ 0 ] ifNotNil: [ :obj | obj stop ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:27'!
analysisIcon
	^ GTSpotterEventIcons noIcon! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:47'!
asEventAnalysisString
	^ String streamContents: [ :stream |
			self eventAnalysisPrintOn: stream ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 13:38'!
children
	^ self infoAt: #sameLevelEvents ifAbsent: [ #() ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:17'!
cleanDiveInEvent: aDiveInEvent 
	^ self removeInfoAt: #diveInEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 23:01'!
dateAndTimeWithFixedTimeZone
	| dateAndTime announcementTimestamp session dates |
	self infoAt: #dateAndTimeWithFixedTimeZone ifPresent: [ :value | ^ value ] ifAbsent: [ "ignore" ].
	dateAndTime := self dateAndTime.
	dateAndTime ifNil: [ ^ nil ].
	announcementTimestamp := self announcementTimestamp.
	announcementTimestamp ifNil: [ 
		^ dateAndTime translateTo: 0 ].
	dateAndTime asDate yyyymmdd = announcementTimestamp asDate yyyymmdd ifTrue: [ 
		^ self 
			infoAt: #dateAndTimeWithFixedTimeZone 
			put: (dateAndTime translateTo: announcementTimestamp offset) ].
	session := self session.
	session ifNil: [ 
		^ dateAndTime translateTo: announcementTimestamp offset ].
	dates := (session collect: #announcementTimestamp as: Set)
		select: [ :eachTimestamp | eachTimestamp asDate yyyymmdd = dateAndTime asDate yyyymmdd ].
	dates ifEmpty: [ 
		^ dateAndTime translateTo: announcementTimestamp offset ].
	^ self 
		infoAt: #dateAndTimeWithFixedTimeZone 
		put: (dateAndTime translateTo: dates any offset)! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:13'!
diveInEvent: aDiveInEvent 
	^ self infoAt: #diveInEvent put: aDiveInEvent.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:15'!
diveInLevel
	^ self parentEvent 
		ifNotNil: [ :obj | obj diveInLevel + 1 ]
		ifNil: [ 1 ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 23:35'!
elementNamePrintOn: aStream
	self elementName 
		ifNil: [ aStream nextPutAll: 'unknown element' ];
		ifNotNil: [ aStream nextPutAll: 'an element' ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:44'!
eventAnalysisPrintOn: aStream
	self printOn: aStream! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:17'!
eventTypePrintOn: aStream
	self eventType
		ifNotNil: [ :aSymbol |
			aStream
				nextPut: $,; 
				space;
				print: aSymbol;
				nextPutAll: ' event' ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 22:50'!
followingDifferentTime
	^ self infoAt: #followingDifferentTime ifAbsent: [ self dateAndTimeWithFixedTimeZone ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:53'!
isForTimelineView
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/8/2015 16:11'!
isMissStep
	^ self infoAt: #isMissStep ifPresent: [ :obj | true ] ifAbsent: [ false ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 13:08'!
isRootEvent
	^ self infoAt: #diveInEvent ifPresent: [ :obj | false ] ifAbsent: [ true ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:30'!
isStrange
	^ self infoAt: #strange ifPresent: [ :aCol | aCol notEmpty ] ifAbsent: [ false ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 11:44'!
markAsStrange: aString
	| stranges |
	stranges := self infoAt: #strange ifAbsentPut: [ OrderedCollection new ].
	stranges add: aString.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:36'!
myPositionAmongSameTimeEvents
	^ self infoAt: #myPositionAmongSameTimeEvents ifAbsent: [ 1 ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:13'!
parentEvent
	^ self infoAt: #diveInEvent ifPresent: [ :obj | obj ] ifAbsent: [ nil ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:47'!
relativeXPosition
	^ self infoAt: #relativeXPosition! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:47'!
relativeXPosition: aDateAndTime 
	^ self infoAt: #relativeXPosition put: aDateAndTime! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:20'!
removeDiveInEvent
	^ self removeInfoKey: #diveInEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:26'!
removeIsMissStep
	^ self removeInfoKey: #isMissStep! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:22'!
removeSameLevelEvents
	^ self removeInfoKey: #sameLevelEvents! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:26'!
removeSameTimeEvents
	self removeInfoKey: #sameTimeEvents.
	self removeInfoKey: #myPositionAmongSameTimeEvents.
	self removeInfoKey: #followingDifferentTime.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:25'!
removeSelectedCategoryEvent
	^ self removeInfoKey: #selectedCategoryEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:25'!
removeSelectedElementEvents
	^ self removeInfoKey: #selectedElementEvents! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 13:59'!
removeSession
	^ self removeInfoKey: #session! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:24'!
removeStrange
	^ self removeInfoKey: #strange! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:18'!
sameTimeEvents
	^ self infoAt: #sameTimeEvents ifAbsent: [ #() ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:16'!
sameTimeEvents: aCollection index: anInteger nextDateAndTime: aDateAndTime 
	self infoAt: #sameTimeEvents put: aCollection.
	self infoAt: #myPositionAmongSameTimeEvents put: anInteger.
	self infoAt: #followingDifferentTime put: aDateAndTime.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 14:02'!
session
	^ self infoAt: #session! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 14:00'!
session: aSessionCollection 
	^ self infoAt: #session put: aSessionCollection.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:43'!
setMissStep
	^ self infoAt: #isMissStep put: true! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 13:50'!
strange
	^ self infoAt: #strange ifAbsent: [ #() ].! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:15'!
addSameLevelEvent: anEvent 
	| events |
	events := self infoAt: #sameLevelEvents ifAbsentPut: [ OrderedCollection new ].
	events add: anEvent! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:34'!
analysisIcon
	^ self isMissStep 
			ifFalse: [ GTSpotterEventIcons diveInCategoryIcon ]
			ifTrue: [ GTSpotterEventIcons diveInCategoryMissStepIcon ]! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/10/2015 17:24'!
duration
	self children ifEmpty: [ ^ 0 seconds ].
	^ (self children last dateAndTime) - self dateAndTime ! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/8/2015 17:26'!
eventAnalysisPrintOn: aStream
	self isMissStep ifTrue: [ aStream nextPutAll: 'MissStep ' ].
	aStream nextPutAll: 'Dive In Category for '.
	aStream 
		print: self duration;
		nextPutAll: ': '.
	self categoryTitle
		ifNil: [ aStream nextPutAll: 'unknown category' ]
		ifNotNil: [ :aString | 
			aStream nextPutAll: aString ].
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasDiveIn
	^ self children contains: #isDiveIn ! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasQuery
	^ self children contains: #isContextChanged! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:46'!
analysisIcon
	^ GTSpotterEventIcons exitIcon! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:05'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Close Spotter'! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:24'!
addSameLevelEvent: anEvent 
	| events |
	events := self infoAt: #sameLevelEvents ifAbsentPut: [ OrderedCollection new ].
	events add: anEvent! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:35'!
analysisIcon
	^ self isMissStep 
			ifFalse: [ GTSpotterEventIcons diveInElementIcon ]
			ifTrue: [ GTSpotterEventIcons diveInElementMissStepIcon ]! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/10/2015 17:25'!
duration
	self children ifEmpty: [ ^ 0 seconds ].
	^ (self children last dateAndTime) - self dateAndTime ! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/8/2015 17:25'!
eventAnalysisPrintOn: aStream
	self isMissStep ifTrue: [ aStream nextPutAll: 'MissStep ' ].
	aStream nextPutAll: 'Dive In Element for '.
	aStream 
		print: self duration;
		nextPutAll: ': '.
	self elementNamePrintOn: aStream.
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasDiveIn
	^ self children contains: #isDiveIn ! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasQuery
	^ self children contains: #isContextChanged! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:44'!
analysisIcon
	^ GTSpotterEventIcons contextChangedIcon! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 23:57'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Context Change: '.
	self currentTextSizes 
			ifEmpty: [ aStream nextPutAll: 'no input' ]
			ifNotEmpty: [ :aCollection | 
					aStream
						print: aCollection size;
						nextPutAll: (aCollection size = 1 
											ifTrue: [ ' word of size ' ] 
											ifFalse: [ ' words, each of size: ' ]).
				aCollection 
					do: [ :eachSize | aStream print: eachSize ] 
					separatedBy: [ aStream space ].
				self hasCurrentTextSpecials ifTrue: [ 
					aStream nextPutAll: ', with #keyword' ] ]! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ self isContextChanged! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:41'!
analysisIcon
	^ GTSpotterEventIcons diveOutIcon! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:22'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Dive Out: '.
	self elementNamePrintOn: aStream.
! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 13:37'!
analysisIcon
	^ GTSpotterEventIcons showPreviewIcon! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:56'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Show Preview'! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:55'!
isForTimelineView
	^ true! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:47'!
analysisIcon
	^ GTSpotterEventIcons actOnIcon! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:26'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Act On: '.
	self elementNamePrintOn: aStream.
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:53'!
isForTimelineView
	^ true! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/8/2015 16:36'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'SearchFinished: ';
		nextPutAll: (query ifNil: [ 'no query' ] ifNotNil: [ 'with query' ]);
		nextPutAll: ', ';
		print: self categories size;
		nextPutAll: ' categories, ';
		print: (self items ifEmpty: [ 0 ] ifNotEmpty: [ :col | col sum ]);
		nextPutAll: ' findings'! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:45'!
analysisIcon
	^ GTSpotterEventIcons selectedCandidateChangedIcon! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 15:50'!
categoryEvent
	^ self infoAt: #selectedCategoryEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 23:30'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Selection of '.
	self elementNamePrintOn: aStream.
	self selectedCategoryLabel ifNotNil: [ :aLabelString |
		aStream
			nextPutAll: ' in category ';
			nextPutAll: aLabelString ].
	self eventTypePrintOn: aStream.
! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ self isUserSelection! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:06'!
selectedCategoryEvent
	^ self infoAt: #selectedCategoryEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 11:48'!
selectedCategoryEvent: anEvent
	self infoAt: #selectedCategoryEvent put: anEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:07'!
selectedCategoryLabel
	^ self selectedCategoryEvent ifNotNil: [ :catEvent | catEvent categoryLabel ]! !

!GTSpotterRecorderOpenEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:56'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Open Spotter'! !

TestCase subclass: #GTATimelineBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTATimelineBuilderTest methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 4/11/2015 16:05'!
session1
	^ GTASessionExamples session1! !

!GTATimelineBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 4/10/2015 16:05'!
setUp
	super setUp.
	builder := GTATimelineBuilder new.! !

!GTATimelineBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 4/11/2015 20:06'!
testBuild
	| events |
	events := GTSpotterSession new.
	GTSpotterRecorderEvent allSubclassesDo: [ :eachClass |
		events add: eachClass new.
	].
	builder data: events.
	builder build.
	builder view.! !

!GTATimelineBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 4/11/2015 20:06'!
testBuildSession1
	| events |
	events := self session1.
	GTSpotterSessionAnalysis updateOn: events.
	builder data: events.
	builder build.
	RTHorizontalLineLayout on: builder view elements.
	builder view.! !

TestCase subclass: #GTATimelineIconBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTATimelineIconBuilderTest commentStamp: '<historical>' prior: 0!
A GTATimelineIconBuilderTest is a test class for testing the behavior of GTATimelineIconBuilder!

!GTATimelineIconBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 4/10/2015 11:09'!
setUp
	super setUp.
	builder := GTATimelineIconBuilder new.
	! !

!GTATimelineIconBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 4/11/2015 20:05'!
testShapeFor
	| shape view |
	view := RTView new.
	GTSpotterRecorderEvent allSubclassesDo: [ :eachClass |
		shape := builder shapeFor: eachClass new.
		shape ifNotNil: [
			view add: shape element ]
	].
	RTHorizontalLineLayout on: view elements.
	view! !

TestCase subclass: #GTSpotterPrintDateAndTimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTSpotterPrintDateAndTimeTest commentStamp: '<historical>' prior: 0!
A GTSpotterPrintDateAndTimeTest is a test class for testing the behavior of GTSpotterPrintDateAndTime!

!GTSpotterPrintDateAndTimeTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 13:44'!
testUCTPlus1
	| dateAndTime string |
	dateAndTime := '2015-03-27T14:59:05.524852+01:00' asDateAndTime.
	string := GTSpotterPrintDateAndTime yyyyMmDdAndHhMmSs: dateAndTime.
	self assert: string equals: '2015-03-27, 13:59:05'.! !

TestCase subclass: #GTSpotterSessionAnalysisTest
	instanceVariableNames: 'analysis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTSpotterSessionAnalysisTest commentStamp: '<historical>' prior: 0!
A GTSpotterDiveInLevelCommandTest is a test class for testing the behavior of GTSpotterDiveInLevelCommand!

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 13:35'!
session1
	^ GTSpotterSession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderDiveInCategoryEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderDiveInElementEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveInCategoryEvent new;
				add: GTSpotterRecorderContextChangedEvent new;
				add: GTSpotterRecorderSelectedCandidateChangedEvent new;
				add: GTSpotterRecorderCategorySelectedEvent new;
				add: GTSpotterRecorderDiveOutEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 15:46'!
session2
	^ GTSpotterSession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderSearchFinishedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:08'!
session3
	"Miss-steps"
	^ GTSpotterSession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderDiveInCategoryEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderSearchFinishedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderSearchFinishedEvent new;
		add: GTSpotterRecorderDiveInElementEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

!GTSpotterSessionAnalysisTest methodsFor: 'running' stamp: 'JurajKubelka 3/31/2015 13:24'!
setUp
	super setUp.
	analysis := GTSpotterSessionAnalysis new.
	! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 11:28'!
testMissStepsSession1
	| session |
	analysis session: self session1.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 27.
	self assert: session numberOfMissSteps equals: 1.
	self assert: (session at: 6) isMissStep.! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 11:29'!
testMissStepsSession2
	| session |
	analysis session: self session2.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 11.
	self assert: session numberOfMissSteps equals: 0.! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 11:04'!
testMissStepsSession3
	| session |
	analysis session: self session3.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 20.
	self assert: (session at: 9) isMissStep.
	self deny: (session at: 16) isMissStep.
	self assert: session numberOfMissSteps equals: 1.! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 3/31/2015 13:41'!
testRootsSession1
	| roots |
	analysis session: self session1.
	analysis execute.
	roots := analysis session roots.
	self assert: roots size equals: 11.
	self assert: (roots at: 6) children size equals: 4.
	self assert: (roots at: 1) children size equals: 0.
	self assert: (roots at: 7) children size equals: 8.
	self assert: ((roots at: 7) children at: 4) children size equals: 4.
! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 3/31/2015 15:53'!
testRootsSession2
	| session |
	analysis session: self session2.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 11.
	self assert: (session at: 4) categoryEvent equals: (session at: 5).
	self assert: (session at: 5) elementSelectionEvents size equals: 3.
	self assert: (session at: 5) elementSelectionEvents first equals: (session at: 4).
	self assert: (session at: 5) elementSelectionEvents second equals: (session at: 7).
	self assert: (session at: 5) elementSelectionEvents third equals: (session at: 8).
	self assert: (session at: 9) categoryEvent equals: (session at: 10).
	self assert: (session at: 10) elementSelectionEvents size equals: 1.
	self assert: (session at: 10) elementSelectionEvents first equals: (session at: 9).
! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 13:38'!
analysisIcon
	^ GTSpotterEventIcons hidePreviewIcon! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:56'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Hide Preview'! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 15:51'!
elementSelectionEvents
	^ self infoAt: #selectedElementEvents ifAbsent: [ #() ]! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:04'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Category: '.
	self categoryLabel
		ifNil: [ aStream nextPutAll: 'unknown category' ]
		ifNotNil: [ :aString |
			aStream 
				nextPutAll: aString;
				nextPutAll: ' with ';
				print: self elementCountOrZero;
				nextPutAll: ' spotted and ';
				print: self selectedElementEvents size;
				nextPutAll: ' selected elements' ]! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 11:40'!
markAsStrange
	^ self infoAt: #strange put: true! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 15:42'!
selectedElementEvent: anEvent
	| elements |
	elements := self infoAt: #selectedElementEvents ifAbsentPut: [ OrderedCollection new ].
	elements add: anEvent! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:02'!
selectedElementEvents
	^ self infoAt: #selectedElementEvents ifAbsent: [ #() ]! !

Object subclass: #GTASessionExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTASessionExamples class methodsFor: 'running' stamp: 'JurajKubelka 4/11/2015 16:04'!
session1
	^ GTSpotterSession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderDiveInCategoryEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderDiveInElementEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveInCategoryEvent new;
				add: GTSpotterRecorderContextChangedEvent new;
				add: GTSpotterRecorderSelectedCandidateChangedEvent new;
				add: GTSpotterRecorderCategorySelectedEvent new;
				add: GTSpotterRecorderDiveOutEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

Object subclass: #GTATimelineBuilder
	instanceVariableNames: 'data view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTATimelineBuilder class methodsFor: 'api' stamp: 'JurajKubelka 4/10/2015 15:26'!
viewOn: objects
	^ self new
			data: objects;
			build;
			view! !

!GTATimelineBuilder methodsFor: 'building' stamp: 'JurajKubelka 4/11/2015 23:18'!
build
	| previousElement edges icons elements visibleData levels shape element |
	view := RTView new.
	view @ RTDraggableView.
	icons := GTATimelineIconBuilder new.
	edges := RTGroup new.
	visibleData := self visibleData.
	previousElement := nil.
	elements := visibleData collect: [ :event |
		shape := icons shapeFor: event.
		element := shape elementOn: event.
		previousElement ifNotNil: [ 
			edges add: (RTLine new 
								withHorizontalAttachPoint;
								width: 2;
							 	edgeFrom: previousElement to: element) ].
		previousElement := element.
		element ] as: RTGroup.
	levels := visibleData deepestDiveIn.
	elements @ RTDraggable @ (RTPopup text: #asEventAnalysisString).
	view addAll: elements; addAll: edges.
	"RTGridLayout on: elements."
	RTHorizontalLineLayout new center; on: elements.
	elements do: [ :eachElement |
		eachElement translateBy: 0 @ (eachElement model diveInLevel * 10) ].
	view .! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/10/2015 15:21'!
data
	^ data! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/10/2015 15:21'!
data: anObject
	data := anObject! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/10/2015 15:21'!
view
	^ view! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/10/2015 15:21'!
view: anObject
	view := anObject! !

!GTATimelineBuilder methodsFor: 'enumerating' stamp: 'JurajKubelka 4/10/2015 15:22'!
visibleData
	^ self data select: #isForTimelineView! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 22:50'!
xFor: aSpotterEvent
	| currentTimeStamp index events nextTimestamp duration relIndex relDuration xPosition |
	aSpotterEvent relativeXPosition ifNotNil: [ :value | ^ value ].
	currentTimeStamp := aSpotterEvent dateAndTimeWithFixedTimeZone.
	index := aSpotterEvent myPositionAmongSameTimeEvents - 1.
	events := aSpotterEvent sameTimeEvents size.
	events < 2 ifTrue: [ 
		aSpotterEvent relativeXPosition: currentTimeStamp. 
		^ currentTimeStamp ].
	relIndex := index / events.
	nextTimestamp := aSpotterEvent followingDifferentTime.
	duration := nextTimestamp - currentTimeStamp / 2.
	relDuration := duration * relIndex.
	xPosition := currentTimeStamp + relDuration.
	aSpotterEvent relativeXPosition: xPosition.
	^ xPosition! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/10/2015 15:25'!
yFor: aSpotterEvent
	^ aSpotterEvent diveInLevel! !

Object subclass: #GTATimelineIconBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTATimelineIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:19'!
defaultHalfHeight
	^ 5! !

!GTATimelineIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:19'!
defaultHeight
	^ 10! !

!GTATimelineIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:19'!
defaultMinHeight
	^ 2! !

!GTATimelineIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:20'!
defaultMinWidth
	^ 1! !

!GTATimelineIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:20'!
defaultWidth
	^ 10! !

!GTATimelineIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 10:21'!
newShapeForWordOfSize: wordSize keyword: aBoolean
	^ RTBox new 
			height: (aBoolean ifTrue: [ self defaultHalfHeight ] ifFalse: [ self defaultHeight ]); 
			width: wordSize; 
			yourself.! !

!GTATimelineIconBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 16:49'!
shapeFor: aGTSpotterEvent 
	^ aGTSpotterEvent accept: self! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:52'!
visitActOnEvent: aGTSpotterEvent 
	^ RTPolygon new vertices: { -5 @ -5. 5 @ 0. -5 @ 5 }; yourself! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:52'!
visitCategorySelectedEvent: aGTSpotterRecorderCategorySelectedEvent 
	^ nil! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 10:00'!
visitContextChangedEvent: aGTSpotterEvent 
	^ aGTSpotterEvent currentTextSizes size < 2
		ifTrue: [ self visitContextChangedForOneWordEvent: aGTSpotterEvent ]
		ifFalse: [ self visitContextChangedForSeveralWordsEvent: aGTSpotterEvent ]! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 10:22'!
visitContextChangedForOneWordEvent: aGTSpotterEvent
	| shape sizes |
	shape := RTBox new height: self defaultHeight; width: self defaultMinWidth; yourself.
	sizes := aGTSpotterEvent currentTextSizes.	
	(sizes notNil and: [ sizes notEmpty ]) ifTrue: [ shape width: sizes sum ].
	aGTSpotterEvent hasCurrentTextSpecials ifTrue: [ shape height: self defaultHalfHeight ]. 
	^ shape! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 10:17'!
visitContextChangedForSeveralWordsEvent: aGTSpotterEvent
	| composition sizes keywords shapes |
	composition := RTCompositeShape new horizontal; yourself.
	sizes := aGTSpotterEvent currentTextSizes.	
	keywords := aGTSpotterEvent currentTextSpecials.
	shapes := OrderedCollection new.
	sizes with: keywords do: [ :size :keyword |
		shapes add: (self newShapeForWordOfSize: size keyword: keyword) ].
	shapes 
		do: [ :shape | composition add: shape ]
		separatedBy: [ 
			composition add: (RTBox new height: 5; width: 1; color: Color transparent; yourself) ].
	^ composition! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 19:33'!
visitDiveInCategoryEvent: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
		vertices: { -3 @ 4. 2 @ -5. 3 @ -4. -2 @ 5 };
		yourself.
	s2 := RTPolygon new 
		vertices: { -3 @ 4. 2 @ -5. 3 @ -4. -2 @ 5 };
		yourself.
	c := RTCompositeShape new.
	c add: s1; add: s2; horizontal.
	^ c! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 19:30'!
visitDiveInElementEvent: aGTSpotterEvent 
	^ RTPolygon new 
		vertices: { -3 @ 4. 2 @ -5. 3 @ -4. -2 @ 5 };
		yourself! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 19:32'!
visitDiveOutEvent: aGTSpotterEvent 
	^ RTPolygon new 
		vertices: { 3 @ 4. -2 @ -5. -3 @ -4. 2 @ 5 };
		yourself! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:53'!
visitExitEvent: aGTSpotterEvent 
	^ RTPolygon new 
		vertices: { 
			-4 @ -5. 0 @ -1. 4 @ -5. 5 @ -4. 1 @ 0. 
			5 @ 4. 4 @ 5. 0 @ 1. -4 @ 5. -5 @ 4. -1 @ 0. -5 @ -4 };
		yourself! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 01:38'!
visitHidePreviewEvent: aGTSpotterEvent 
	^ RTArc new 
			innerRadius: 4;
			externalRadius: 5;
			outerAngle: 0 innerAngle: 360! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:53'!
visitOpenEvent: aGTSpotterRecorderOpenEvent 
	^ nil! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:53'!
visitSearchFinishedEvent: aGTSpotterRecorderSearchFinishedEvent 
	^ nil! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 18:42'!
visitSelectedCandidateChangedEvent: aGTSpotterEvent 
	| type |
	type := aGTSpotterEvent eventType. 
	type = #keyPressedArrowUp ifTrue: [ 
		^ self visitSelectedCandidateChangedEventKeyPressedArrowUp: aGTSpotterEvent ].

	type = #keyPressedArrowDown ifTrue: [ 
		^ self visitSelectedCandidateChangedEventKeyPressedArrowDown: aGTSpotterEvent ].

	type = #singleClick ifTrue: [ 
		^ self visitSelectedCandidateChangedEventSingleClick: aGTSpotterEvent ].

	^ RTPolygon new 
			vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0. 0 @ 5 };
			color: Color transparent;
			borderColor: RTPolygon new defaultColor;
			yourself! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 19:22'!
visitSelectedCandidateChangedEventKeyPressedArrowDown: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 1 . 0 @ 5 . 5 @ 1. 5 @ -1. -5 @ -1 };
				yourself.
	s2 := RTBox new width: 10; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 23:26'!
visitSelectedCandidateChangedEventKeyPressedArrowUp: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ -1 . 0 @ -5 . 5 @ -1. 5 @ 1. -5 @ 1 };
				yourself.
	s2 := RTBox new width: 10; height: 6; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s1; add: s2; vertical.
	^ c! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 18:42'!
visitSelectedCandidateChangedEventSingleClick: aGTSpotterEvent 
	^ RTPolygon new 
			vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0. 0 @ 5 };
			yourself! !

!GTATimelineIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 00:21'!
visitShowPreviewEvent: aGTSpotterEvent 
	^ RTEllipse new size: 10; yourself! !

Object subclass: #GTSpotterAnalysisCommand
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterAnalysisCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:13'!
analysisOrder
	^ 100! !

!GTSpotterAnalysisCommand class methodsFor: 'instance creation' stamp: 'JurajKubelka 3/31/2015 11:30'!
context: aGTSpotterSession 
	^ self new context: aGTSpotterSession; yourself! !

!GTSpotterAnalysisCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:12'!
clean
	self subclassResponsibility! !

!GTSpotterAnalysisCommand methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:30'!
context
	^ context! !

!GTSpotterAnalysisCommand methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:30'!
context: anObject
	context := anObject! !

!GTSpotterAnalysisCommand methodsFor: 'execute' stamp: 'JurajKubelka 3/31/2015 11:31'!
execute
	self subclassResponsibility! !

!GTSpotterAnalysisCommand methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:32'!
session
	^ self context session! !

GTSpotterAnalysisCommand subclass: #GTSpotterDiveInLevelCommand
	instanceVariableNames: 'dives'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterDiveInLevelCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:14'!
analysisOrder
	^ 1! !

!GTSpotterDiveInLevelCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:23'!
clean
	self session do: [ :eachEvent |
		eachEvent
			removeDiveInEvent;
			removeSameLevelEvents ]! !

!GTSpotterDiveInLevelCommand methodsFor: 'execute' stamp: 'JurajKubelka 3/31/2015 12:00'!
execute
	self session do: [ :eachEvent |
		eachEvent isDiveIn ifTrue: [ self updateDiveIn: eachEvent ].
		eachEvent isDiveOut ifTrue: [ self updateDiveOut: eachEvent ].
		eachEvent isDive ifFalse: [ self updateEvent: eachEvent ].
	]! !

!GTSpotterDiveInLevelCommand methodsFor: 'initialization' stamp: 'JurajKubelka 3/31/2015 12:06'!
initialize
	super initialize.
	dives := OrderedCollection new! !

!GTSpotterDiveInLevelCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:58'!
updateDiveIn: anEvent
	self updateEvent: anEvent.
	dives add: anEvent.
! !

!GTSpotterDiveInLevelCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:11'!
updateDiveOut: anEvent
	dives ifEmpty: [ ^ anEvent markAsStrange: 'Dive-Out before Dive-In.' ].
	self updateEvent: anEvent.
	dives removeLast ! !

!GTSpotterDiveInLevelCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 12:11'!
updateEvent: anEvent
	dives ifEmpty: [ ^ self ].
	anEvent diveInEvent: dives last.
	dives last addSameLevelEvent: anEvent.
! !

GTSpotterAnalysisCommand subclass: #GTSpotterElementWithCategoryCommand
	instanceVariableNames: 'selection category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterElementWithCategoryCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:10'!
analysisOrder
	^ 1! !

!GTSpotterElementWithCategoryCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:25'!
clean
	self session do: [ :eachEvent |
		eachEvent
			removeStrange;
			removeSelectedCategoryEvent;
			removeSelectedElementEvents ]! !

!GTSpotterElementWithCategoryCommand methodsFor: 'execute' stamp: 'JurajKubelka 3/31/2015 11:37'!
execute
	self session do: [ :eachEvent |
		eachEvent isUserSelectionClass ifTrue: [ self updateSelection: eachEvent ].
		eachEvent isCategorySelection ifTrue: [ self updateCategory: eachEvent ].
	]! !

!GTSpotterElementWithCategoryCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 15:44'!
updateCategory: anEvent
	selection ifNil: [ ^ anEvent markAsStrange: 'Category selection before element selection.' ].
	selection selectedCategoryEvent: anEvent.
	anEvent selectedElementEvent: selection.
	selection := nil.
	category := anEvent.! !

!GTSpotterElementWithCategoryCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 15:43'!
updateSelection: anEvent
	selection ifNotNil: [ 
		category 
			ifNil: [ selection markAsStrange: 'There is no category selection before.' ]
			ifNotNil: [ :aCategory | 
				selection selectedCategoryEvent: aCategory.
				aCategory selectedElementEvent: selection.  ]
		 ].
	selection := anEvent.! !

GTSpotterAnalysisCommand subclass: #GTSpotterLinkToSessionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterLinkToSessionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:09'!
analysisOrder
	^ 1! !

!GTSpotterLinkToSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 13:59'!
clean
	self session do: [ :eachEvent |
		eachEvent removeSession ]! !

!GTSpotterLinkToSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 13:59'!
execute
	self session do: [ :eachEvent |
		eachEvent session: self session ]! !

GTSpotterAnalysisCommand subclass: #GTSpotterMissStepsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterMissStepsCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:14'!
analysisOrder
	^ 50! !

!GTSpotterMissStepsCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:26'!
clean
	self session do: [ :eachEvent |
		eachEvent
			removeIsMissStep ]! !

!GTSpotterMissStepsCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/8/2015 16:53'!
execute
	| divesIn |
	divesIn := self session select: #isDiveIn.
	divesIn withIndexDo: [ :aDiveIn :index |
		(index + 1) <= divesIn size ifTrue: [ 
			((aDiveIn hasQuery or: [ aDiveIn hasDiveIn ]) not and:
				[ aDiveIn duration < 3 seconds ]) ifTrue: [ 
				aDiveIn setMissStep.
			]
		]
	]! !

GTSpotterAnalysisCommand subclass: #GTSpotterSameTimestampCommand
	instanceVariableNames: 'timestamp events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterSameTimestampCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:08'!
analysisOrder
	^ GTSpotterLinkToSessionCommand analysisOrder + 1! !

!GTSpotterSameTimestampCommand methodsFor: 'adding' stamp: 'JurajKubelka 4/9/2015 19:09'!
addEvent: aSpotterEvent 
	events ifNil: [ events := OrderedCollection new ].
	events addLast: aSpotterEvent! !

!GTSpotterSameTimestampCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 19:25'!
clean
	self session do: [ :event | event removeSameTimeEvents ]! !

!GTSpotterSameTimestampCommand methodsFor: 'adding' stamp: 'JurajKubelka 4/9/2015 19:27'!
consolidateEvents: aDateAndTime 
	events ifNil: [ ^ self ].
	events withIndexDo: [ :event :index |
		event sameTimeEvents: events index: index nextDateAndTime: aDateAndTime ].
	events := nil.! !

!GTSpotterSameTimestampCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/11/2015 22:50'!
execute
	| eventTimestamp |
	self session do: [ :eachEvent | 
		eventTimestamp := eachEvent dateAndTimeWithFixedTimeZone.
		timestamp 
			ifNil: [ 
				timestamp := eventTimestamp.
				self addEvent: eachEvent. ]
			ifNotNil: [ 
				timestamp = eventTimestamp 
					ifTrue: [ self addEvent: eachEvent ] 
					ifFalse: [ self consolidateEvents: eventTimestamp.
						timestamp := eventTimestamp.
						self addEvent: eachEvent. ] ]
		 ].
	self consolidateEvents: eventTimestamp! !

Object subclass: #GTSpotterEventIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Support'!

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 13:36'!
actOnIcon
	^ Smalltalk ui icons glamorousPlay! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:43'!
contextChangedIcon
	^ Smalltalk ui icons glamorousEdit  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:20'!
diveInCategoryIcon
	^ Smalltalk ui icons glamorousDiveAllRightIcon  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 20:55'!
diveInCategoryMissStepIcon
	^ Smalltalk ui icons glamorousDiveAllRightIcon
		deepCopy 
			mapColor: (Color r: 0.581 g: 0.581 b: 0.581 alpha: 1.0)
			to: Color red! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:26'!
diveInElementIcon
	^ Smalltalk ui icons glamorousDiveRightIcon  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 20:55'!
diveInElementMissStepIcon
	^ Smalltalk ui icons glamorousDiveRightIcon 
			deepCopy mapColor: Color black to: Color red! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:41'!
diveOutIcon
	^ Smalltalk ui icons glamorousLeft  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:46'!
exitIcon
	^ Smalltalk ui icons glamorousClose  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 13:37'!
hidePreviewIcon
	^ Smalltalk ui icons glamorousZoomOut! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:26'!
noIcon
	^ Smalltalk ui icons protocolNoneIcon! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:45'!
selectedCandidateChangedIcon
	^ Smalltalk ui icons glamorousGrayCircle  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 13:37'!
showPreviewIcon
	^ Smalltalk ui icons glamorousZoomIn! !

Object subclass: #GTSpotterPrintDateAndTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Support'!

!GTSpotterPrintDateAndTime class methodsFor: 'api' stamp: 'JurajKubelka 4/9/2015 13:48'!
yyyyMmDdAndHhMmSs: aDateAndTimeOrZero
	"Returns YYYY-MM-DD, HH:MM:SS in UTC time."
	aDateAndTimeOrZero = 0 ifTrue: [ ^ 'unknown' ].
	^ String streamContents: [ :aStream |
		aDateAndTimeOrZero asUTC printYMDOn: aStream.
		aStream nextPutAll: ', '.
		aDateAndTimeOrZero asUTC printHMSOn: aStream ] ! !

Object subclass: #GTSpotterSessionAnalysis
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterSessionAnalysis class methodsFor: 'api' stamp: 'JurajKubelka 3/31/2015 11:50'!
executeOn: aGTSpotterSession
	^ (self session: aGTSpotterSession) execute! !

!GTSpotterSessionAnalysis class methodsFor: 'instance creation' stamp: 'JurajKubelka 3/31/2015 11:28'!
session: aGTSpotterSession 
	^ self new session: aGTSpotterSession; yourself! !

!GTSpotterSessionAnalysis class methodsFor: 'api' stamp: 'JurajKubelka 4/9/2015 11:13'!
updateOn: aGTSpotterSession
	^ (self session: aGTSpotterSession) clean; execute! !

!GTSpotterSessionAnalysis methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:15'!
clean
	(GTSpotterAnalysisCommand allSubclasses 
		sort: [ :a :b | a analysisOrder < b analysisOrder ]) 
			do: [ :each | | command |
				command := each context: self.
				command clean ].
	^ self session! !

!GTSpotterSessionAnalysis methodsFor: 'execute' stamp: 'JurajKubelka 4/8/2015 16:31'!
execute
	(GTSpotterAnalysisCommand allSubclasses 
		sort: [ :a :b | a analysisOrder < b analysisOrder ]) 
			do: [ :each | | command |
				command := each context: self.
				command execute ].
	^ self session! !

!GTSpotterSessionAnalysis methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:28'!
session
	^ session! !

!GTSpotterSessionAnalysis methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:28'!
session: anObject
	session := anObject! !

Object subclass: #GTSpotterSessionsBuilder
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterSessionsBuilder commentStamp: 'JurajKubelka 3/31/2015 11:24' prior: 0!
I'm a session builder, I receive collected announcements and split events per computer and per session. Session starts with opening Spotter and finishs on closing Spotter.!

!GTSpotterSessionsBuilder class methodsFor: 'api' stamp: 'JurajKubelka 3/30/2015 15:48'!
fromEvents: aCollection 
	^ self new events: aCollection; sessions! !

!GTSpotterSessionsBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 15:48'!
events: aCollection 
	events := aCollection! !

!GTSpotterSessionsBuilder methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 15:44'!
sessions 
	| borders pairs openOrExit previousAssociation |
	events ifEmpty: [ ^ GTSpotterSessions new ].
	borders := events withIndexCollect: [ :event :index |
		event isOpenOrCloseSpotter 
				ifTrue: [ index -> event ]
				ifFalse: [ nil ]
		 ].
	borders := borders select: [ :each | each notNil ].
	pairs := OrderedCollection new.
	openOrExit := #open.
	previousAssociation := borders first.
	borders do: [ :eachAssociation |
		(openOrExit = #open) 
			ifTrue: [ 
				eachAssociation value isOpenSpotter ifTrue: [ 
					pairs addLast: eachAssociation. 
					openOrExit := #exit ] ]
			ifFalse: [ 
				eachAssociation value isCloseSpotter ifTrue: [ 
					pairs at: (pairs size) put: (pairs last) -> eachAssociation. 
					openOrExit := #open ].
				eachAssociation value isOpenSpotter ifTrue: [ 
					pairs at: (pairs size) put: (pairs last) -> previousAssociation.
					pairs addLast: eachAssociation.
					openOrExit := #exit ] ].
		previousAssociation := eachAssociation.
	].
	openOrExit = #exit ifTrue: [ pairs removeLast ].
	^ pairs collect: [ :eachPair | | open exit |
		open := eachPair key.
		exit := eachPair value.
		GTSpotterSession withAll: (events copyFrom: open key to: exit key).
		 ] as: GTSpotterSessions.! !

Object subclass: #GTSpotterTimeline
	instanceVariableNames: 'data view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Support'!

!GTSpotterTimeline class methodsFor: 'api' stamp: 'JurajKubelka 4/9/2015 18:34'!
viewOn: objects
	^ self new
			data: objects;
			build;
			view! !

!GTSpotterTimeline methodsFor: 'building' stamp: 'JurajKubelka 4/9/2015 20:37'!
build
	| shape elements visibleData levels |
	view := RTView new.
	view @ RTDraggableView.
	shape := RTBitmap new.
	shape form: #analysisIcon.
	visibleData := self visibleData.
	levels := visibleData deepestDiveIn.
	elements := shape elementsOn: visibleData.
	elements @ RTDraggable @ (RTPopup text: #asEventAnalysisString).
	"RTGridLayout on: elements."
	RTMetricNormalizer new
		elements: elements;
		normalizeX: [ :eachEvent | self xFor: eachEvent ] min: 0 max: 500;
		normalizeY: [ :eachEvent | self yFor: eachEvent ] min: 0 max: (levels * 4).
	view addAll: elements.! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:34'!
data
	^ data! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:34'!
data: anObject
	data := anObject! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:35'!
view
	^ view! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:35'!
view: anObject
	view := anObject! !

!GTSpotterTimeline methodsFor: 'enumerating' stamp: 'JurajKubelka 4/9/2015 19:52'!
visibleData
	^ self data select: #isForTimelineView! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:14'!
xFor: aSpotterEvent
	| currentTimeStamp index events nextTimestamp duration relIndex relDuration xPosition |
	aSpotterEvent relativeXPosition ifNotNil: [ :value | ^ value ].
	currentTimeStamp := aSpotterEvent dateAndTimeWithFixedTimeZone.
	index := aSpotterEvent myPositionAmongSameTimeEvents - 1.
	events := aSpotterEvent sameTimeEvents size.
	events < 2 ifTrue: [ 
		aSpotterEvent relativeXPosition: currentTimeStamp. 
		^ currentTimeStamp ].
	relIndex := index / events.
	nextTimestamp := aSpotterEvent followingDifferentTime.
	duration := nextTimestamp - currentTimeStamp / 2.
	relDuration := duration * relIndex.
	xPosition := currentTimeStamp + relDuration.
	aSpotterEvent relativeXPosition: xPosition.
	^ xPosition! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 20:15'!
yFor: aSpotterEvent
	^ aSpotterEvent diveInLevel! !
